library fields.default_transforms;

import 'package:fields/transform.dart';

void registerDefaultTransforms() {  
  Transform.register(const _IntToNumTransform());
  Transform.register(const _NumToIntTransform());
  Transform.register(const _StringToIntTransform());
  Transform.register(const _StringToDoubleTransform());
}

class _IntToNumTransform extends Transform<int, num> {
  const _IntToNumTransform();
  call(value) => value;
}

class _NumToIntTransform extends Transform<num, int> {
  const _NumToIntTransform();
  call(value) => value.toInt();
}

class _StringToIntTransform extends Transform<String, int> {
  const _StringToIntTransform();
  call(value) {
    try {
      return int.parse(value);
    } on FormatException catch(e) {
      throw new TransformError(cause: e);
    }
  }
}

class _StringToDoubleTransform extends Transform<String, double> {
  const _StringToDoubleTransform();
  call(value) {
    try {
      return double.parse(value);      
    } on FormatException catch(e) {
      throw new TransformError(cause: e);
    }
  }
}
